function measure(max_exp_id, n_packets, interval, power_level)
msz = 6; %MarkerSize
fontsize = 15;

folder = sprintf(...
    '/u/maoy/GeoRouting/cr/eval/measure_%d_%d_%d',...
    n_packets,interval, power_level);

for exp_id=1:max_exp_id
  fn = sprintf('%s/%.4d.count', folder, exp_id);
  tmpdist = load(fn);
  [m n]=size(tmpdist);
  loss(:,:,exp_id) = tmpdist(2:m, :);
  node_id(1:n) = tmpdist(1,:);
end

m = mean(loss,3)
std(loss,0,3)
abs(m-m')
x(1:max_exp_id) = loss(6,8,:)
x(1:max_exp_id) = loss(8,6,:)
node_id(8)
node_id(6)

find(loss>100)
hist(loss(:),100)
xlim([0,100])
saveas(gcf,'m_hist.eps','psc2');

figure(2)
set(gca, 'FontSize',fontsize);
hold on
tmp = loss(31,4,:);
plot(1:max_exp_id, tmp(:),'b-o','MarkerSize', msz)
tmp = loss(4,31,:);
plot(1:max_exp_id, tmp(:),'b-^','MarkerSize', msz)

tmp = loss(1, 35,:);
plot(1:max_exp_id, tmp(:),'r-x','MarkerSize', msz)
tmp = loss(35,1,:);
plot(1:max_exp_id, tmp(:),'r-<','MarkerSize', msz)
ylim([0 100])
legend('link quality 31-4','link quality 4-31',...
       'link quality 1-35','link quality 35-1',3)
xlabel('time series (1 unit = 15 minutes)')
ylabel('packet deliver rate (percentage)')
saveas(gcf,'m_lossrate_pair.eps','psc2');

connection = (n_packets./m<=2).*(n_packets./m'<=2);
return
dist = allpair_dijkstra(connection)
coord = load('~/GeoRouting/cr/eval/25coords');
figure(3)

visualize(connection, coord, 1:6)
saveas(gcf,'m_topology.eps','psc2');
