function plot_cumu_matrix(m,str, precision, ignore_inf)
%Plot data in a CDF format
%m: data points
%str: plot string, default empty
%precision: how precise do we want, default 1000
%ignore_inf: ignore the entries where inf is used
if nargin<3 precision=500; end
if nargin<2 str=''; end
if nargin<4 ignore_inf=0; end

sorted = sort(m(:));
if ignore_inf
  sorted = sorted(find(sorted<inf));
end
N = length(sorted);
m = N;
if N>precision m=precision; end
m_array = 1/m:1/m:1;
pos_array = round(m_array.*N);
plot(sorted(pos_array), m_array, str);

return
%plot a cumulative graph of matrix m with M*N
    [M,N] = size(m);
    a = M*N;
    m_array = 1/a:1/a:1;
    f_array = reshape(m,1,a);
    plot(sort(f_array),m_array,str)

