function res = simulation(topo_fn, n_beacons, temp_test)
S = load(topo_fn);
D = S.D;
coord = S.coord;
n_nodes = S.n_nodes;
n_random_pairs = S.n_random_pairs;
random_pairs = S.random_pairs;

clear S;

k = min(n_beacons, 10); %routing beacon for bvr
%k = n_beacons; %!!!!!!!!!!!!!!!!!!
rand('state',100*sum(clock)+10000*(ceil(cputime)-cputime));
tmp = randperm(n_nodes);
beacons = tmp(1:n_beacons);
if nargin==3
  beacons = 1:n_beacons;
end

failure_nodes = [];

[routing_path, routing_dist_bvr_2h, load_bvr_2h, storage_bvr_2h, ...
 dht_bvr, failure_bvr_2h, state_per_node_bvr_2h,transmission_dist_bvr_2h,...
 routing_hops_2h, nodes_with_2hop_info, extra_control_traffic_2h]=bvr(D, n_beacons, ...
  k , beacons, random_pairs, 1, failure_nodes, 0, 1, 1);
failure_bvr_2h_real = length(find(routing_dist_bvr_2h==Inf))/ ...
  n_random_pairs

[routing_path, routing_dist_bvr_sf, load_bvr_sf, storage_bvr, ...
 dht_bvr, failure_bvr_sf,state_per_node_bvr_sf,transmission_dist_bvr_sf,routing_hops_sf]=bvr(D, n_beacons, ...
  k , beacons, random_pairs, 1, failure_nodes, 0, 1, 0);
failure_bvr_sf_real = length(find(routing_dist_bvr_sf==Inf))/ ...
  n_random_pairs

[routing_dist_cr, load_cr,storage_cr, dht_cr, cluster_cr, dv_packets_cr, dv_entries_cr] = ...
  compactrouting(D, beacons, random_pairs,failure_nodes, 2, coord);%distance vector
failure_cr = length(find(routing_dist_cr==Inf))/n_random_pairs;

res = struct(...
    'failure_bvr',failure_bvr_sf, ...
    'failure_bvr_real',failure_bvr_sf_real, ...
    'failure_bvr_2h', failure_bvr_2h, ...
    'failure_bvr_2h_real', failure_bvr_2h_real, ...
    'failure_cr', failure_cr, ...
    'routing_dist_bvr_2h', routing_dist_bvr_2h, ...
    'routing_dist_bvr_sf', routing_dist_bvr_sf, ...
    'routing_hops_2h', routing_hops_2h, ...
    'routing_hops_sf', routing_hops_sf, ...
    'transmission_dist_bvr_2h', transmission_dist_bvr_2h, ...
    'transmission_dist_bvr_sf', transmission_dist_bvr_sf, ...
    'routing_dist_cr',routing_dist_cr, ...
    'load_bvr_2h', load_bvr_2h, ...
    'load_bvr_sf', load_bvr_sf, ...
    'load_cr',load_cr, ...
    'beacons',beacons, ...
    'cluster_cr', cluster_cr, ...
    'dv_packets_cr', dv_packets_cr, ...
    'dv_entries_cr', dv_entries_cr, ...
    'nodes_with_2hop_info', nodes_with_2hop_info,...
    'extra_control_traffic_2h',extra_control_traffic_2h,...
    'state_per_node_bvr_2h', state_per_node_bvr_2h, ...
    'state_per_node_bvr_sf', state_per_node_bvr_sf);

