function [ D, dist] = vis_testbed(fn)
%based on the routing table that dumpped from the testbed, 
% plot the topology graph, an compute average degree, etc

if nargin<1
  fn = '~/GeoRouting/cr/eval/rt_p3.matlab';
end
r = load(fn);
[item tmp] = size(r);
n = r(item,1);
D = zeros(n, n);
for i=1:item
  D(r(i,1),r(i,2))=1;
end
D(1,11)=1;
connection = D | D';

fprintf('degrees: ');
sum(connection)
fprintf('average degree %.3f\n',mean(sum(connection)))
dist = allpair_dijkstra(connection);
fprintf('diameter: %d\n', max(dist(:)))

coord = load('~/GeoRouting/cr/eval/coords');
visualize(connection, coord)
axis off
saveas(gcf, 'testbed_topology.eps','psc2')
